package org.jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import java.util.Comparator;
import java.util.List;
import java.util.function.BiFunction;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import org.junit.Test;

public class CollectorTeeingTest {

	@Test
	public void filter_two_list() {

		List<List<String>> twoLists = Stream
				.of("Mary Zheng", "Alex Zheng", "Java Code Geeks", "Allen Zheng", "Software Developer", "Mary Johnshon")
				.collect(Collectors.teeing(filterList("Zheng"), filterList("Mary"), mergeTwoList()));

		assertEquals(3, twoLists.get(0).size());
		assertEquals(2, twoLists.get(1).size());
	}

	private Collector<String, ?, List<String>> filterList(String matchingStr) {
		return Collectors.filtering(n -> n.contains(matchingStr), Collectors.toList());
	}

	private BiFunction<List<String>, List<String>, List<List<String>>> mergeTwoList() {
		return (List<String> list1, List<String> list2) -> List.of(list1, list2);
	}

	@Test
	public void find_min_max_with_teeing() {
		var minMaxList = Stream.of(1, 3, 6, 7, 12)
				.collect(Collectors.teeing(Collectors.minBy(Comparator.comparing(Integer::intValue)),
						Collectors.maxBy(Comparator.comparing(Integer::intValue)), List::of));

		assertEquals(1, minMaxList.get(0).get().intValue());
		assertEquals(12, minMaxList.get(1).get().intValue());
	}

}
