package org.jcg.zheng.demo;

import static org.junit.Assert.*;

import java.text.NumberFormat;
import java.util.Locale;

import org.junit.Test;

public class CompactNumberFormatTest {

	@Test
	public void test_default() {
		NumberFormat fmt = NumberFormat.getCompactNumberInstance();
		String formatedNumber = fmt.format(1000);
		assertEquals("1K", formatedNumber);
	}
	
	@Test
	public void test_short_format_1k() {
		NumberFormat fmt = NumberFormat.getCompactNumberInstance(Locale.US, NumberFormat.Style.SHORT);
		String formatedNumber = fmt.format(1000);
		assertEquals("1K", formatedNumber);
	}
	
	@Test
	public void test_short_format_1m() {
		NumberFormat fmt = NumberFormat.getCompactNumberInstance(Locale.US, NumberFormat.Style.SHORT);
		String formatedNumber = fmt.format(1000000);
		assertEquals("1M", formatedNumber);
	}

	@Test
	public void test_long_format_1m() {
		NumberFormat fmt = NumberFormat.getCompactNumberInstance(Locale.US, NumberFormat.Style.LONG);
		String formatedNumber = fmt.format(1000000);
		assertEquals("1 million", formatedNumber);
	}
	
	@Test
	public void test_long_format_1k() {
		NumberFormat fmt = NumberFormat.getCompactNumberInstance(Locale.US, NumberFormat.Style.LONG);
		String formatedNumber = fmt.format(1000);
		assertEquals("1 thousand", formatedNumber);
	}
}
