package org.jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import java.util.function.Function;

import org.junit.Test;

class Name {
	private String firstName;

	private String lastName;

	public Name(String firstName, String lastName) {
		super();
		this.firstName = firstName;
		this.lastName = lastName;
	}

	@Override
	public String toString() {
		return "Name [firstName=" + firstName + ", lastName=" + lastName + "]";
	}
}

public class StringTest {

	@Test
	public void test_indent_postive() {
		String message = "This is some text message";
		System.out.println(message);
		String indentedStr = message.indent(5);
		System.out.println(indentedStr);
	}

	@Test
	public void test_indent_nagative() {
		String str = "  first line\n  2nd line\n  3rd line";
		System.out.println(str);
		String indentedStr = str.indent(-2);
		System.out.println("-- negatively indented string --");
		System.out.println(indentedStr);
	}

	@Test
	public void test_transform() {
		String str = "100";
		Integer integer = str.transform(Integer::parseInt);
		assertEquals(100, integer.intValue());
	}

	@Test
	public void test_transform_pojo() {

		Function<String, Name> convertName = str -> {
			int i = str.indexOf(" ");
			String firstNm = str.substring(0, i);
			String lastNm = str.substring(i + 1);
			Name nm = new Name(firstNm, lastNm);
			return nm;
		};

		String str = "Mary Zheng";

		Name toName = str.transform(convertName);
		
		assertEquals("Name [firstName=Mary, lastName=Zheng]", toName.toString());
	}

}
