package org.jcg.zheng.demo.preview;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class SwitchTest {

	@Test
	public void test_Switch_statement() {
		Day day = Day.FRIDAY;
		switch (day) {
		case MONDAY, TUESDAY -> System.out.println("Back to work.");
		case WEDNESDAY -> System.out.println("Wait for the end of week...");
		case THURSDAY, FRIDAY -> System.out.println("Plan for the weekend?");
		case SATURDAY, SUNDAY -> System.out.println("Enjoy the holiday!");
		}
	}

	@Test
	public void test_Switch_expression_2() {
		Day day = Day.FRIDAY;
		String message = switch (day) {
		case MONDAY, TUESDAY -> "Back to work.";
		case WEDNESDAY -> "Wait for the end of week...";
		case THURSDAY, FRIDAY -> "Plan for the weekend?";
		case SATURDAY, SUNDAY -> "Enjoy the holiday!";
		default -> throw new IllegalArgumentException("Seriously?!");
		};

		assertEquals("Plan for the weekend?", message);
	}

	@Test
	public void test_switch_before_jdk12() {

		int nameLetterCounts = 0;
		String testName = "MARY";
		switch (testName) {
		case "MARY":
			nameLetterCounts = 4;
			break;
		case "ZHENG":
			nameLetterCounts = 5;
			break;
		}

		assertEquals(4, nameLetterCounts);
	}

}

enum Day {
	MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY
}
